#include "stm8s_conf.h"
#include "My_OneWire.h"
#include "My_DS18B20.h"
/**
  *inc->stm8s_conf.h - раскоментировать строчки с нужными хедерами 
  *периферии и необходимыми обработчиками прерываний. Все закоментированные
  *обработчики ведут на бесконечные циклы.
  * 
  *Project->Options->General Options - выбрать мк
  *
  *Project->Options->Debugger - выбрать отладчик
  *
  *Project->Options->C/C++ Compiler->Preprocessor->Defined symbols  - задать
  *семейство процессора(перечислены в lib->SPL->inc->stm8s.h), а также задать
  *частоты внутренних и внешних генераторов(если не задать, то будут ипользованы
  *значения по умолчанию из stm8s.h).
  */


//PB5 - LED
//D1 - minus
//C7 - plus

#define KEY_P_PORT GPIOD
#define KEY_P_PIN GPIO_PIN_1

#define KEY_M_PORT GPIOC
#define KEY_M_PIN GPIO_PIN_7

#define CS_PORT GPIOC
#define CS_PIN GPIO_PIN_4

#define CS_H  GPIO_WriteHigh(CS_PORT, CS_PIN)
#define CS_L  GPIO_WriteLow(CS_PORT, CS_PIN)


#define LED_PORT GPIOB
#define LED GPIO_PIN_5


#define TIM4_PERIOD       124
#define TIM4_US_PERIOD       5
  
#define TIMER_LONG_PRESS 1000
    
uint16_t u16Timer_P, u16Timer_M;
   

uint16_t count;
ErrorStatus status = ERROR;
uint16_t uiCounter_1S = 0;

uint32_t u32Millis = 0; // счетчик миллисекунд

bool b_1S_Flag = FALSE;// флаг срабатывания таймера на 1 с

uint8_t u8LedBuffer[8];

uint8_t a; //временная

bool bKey_M_Old = TRUE;
bool bKey_P_Old = TRUE;

bool b_Key_M_Press_Flag = FALSE;
bool b_Key_P_Press_Flag = FALSE;

bool b_Key_M_Long_Press_Flag = FALSE;
bool b_Key_P_Long_Press_Flag = FALSE;
    
bool b_Key_Scan_Flag = FALSE;    


//Данные в EEPROM
#pragma location=0x4000
__no_init uint8_t data;

uint8_t CharSet[] = {
0x7E, // 0
0x30, // 1
0x6d, // 2
0x79, // 3
0x33, // 4
0x5B, // 5
0x5F, // 6
0x70, // 7
0x7F, // 8
0x7B, // 9
0x77, // A
0x1F, // b
0x4E, // C
0x3D, // d
0x4F, // E
0x47, // F
0x01 // -



};



//-------------------------Function prototype----------------------------------
void Tim4_Init();
void SysClock_Cong();
void SPI_Conf();
void GPIO_Conf();
void TIM4_Conf();
void Shift(uint8_t addr, uint8_t data);

void delay_ms(uint16_t ms);

void actionKeyScan(void);
    
void actionTimer_1S(void);
void actionKey_P_Press(void);
void actionKey_M_Press(void);

void actionKey_P_Long_Press(void);
void actionKey_M_Long_Press(void);


//-------------------------Main Function---------------------------------------

void actionKeyScan(void)
{
//////////////////////////////////////////////////////////////////////////////
  //Сканирование кнопок
  //////////////////////////////////////////////////////////////////////////////
  
  if((KEY_P_PORT->IDR & KEY_P_PIN) == 0) // Кнопка +
  {
    if(bKey_P_Old == TRUE)
    {
      //Произошло нажатие кнопки
      bKey_P_Old = FALSE;
      //Запуск обработчика
      u16Timer_P = 1;
      b_Key_P_Press_Flag = TRUE;
    }
    else
    {
      //Кнопка зажатаб можно считать время зажатия
      if(u16Timer_P > 0)
      {
        if(u16Timer_P > TIMER_LONG_PRESS)
        {
          u16Timer_P = 0;
          b_Key_P_Long_Press_Flag = TRUE;
        }
        else u16Timer_P++;
      }
      
    }
  }
  else
  {
    if(bKey_P_Old == FALSE)
    {
      //Произошло отпускание кнопки
      bKey_P_Old = TRUE;
      u16Timer_P = 0;
    }
  }
  
  //////////////////////////////////////////////////////////////////////////////
  
  if((KEY_M_PORT->IDR & KEY_M_PIN) == 0) // Кнопка -
  {
    if(bKey_M_Old == TRUE)
    {
      //Произошло нажатие кнопки
      bKey_M_Old = FALSE;
      //Запуск обработчика
      u16Timer_M = 1;
      b_Key_M_Press_Flag = TRUE;
    }
    else
    {
      //Кнопка зажатаб можно считать время зажатия
      if(u16Timer_M > 0)
      {
        if(u16Timer_M > TIMER_LONG_PRESS)
        {
          u16Timer_M = 0;
          b_Key_M_Long_Press_Flag = TRUE;
        }
        else u16Timer_M++;
      }
      
    }
  }
  else
  {
    if(bKey_M_Old == FALSE)
    {
      //Произошло отпускание кнопки
      bKey_M_Old = TRUE;
      u16Timer_M = 0;
    }
  }
  //////////////////////////////////////////////////////////////////////////////

  b_Key_Scan_Flag = FALSE;
}    
    



/*****************************************************************************
*
*   Имя функции : actionKey_P_Press 
*
*   Возвращаемые значения :  Нет
*                           
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void actionKey_P_Press(void)
{
a++;
Shift(8, CharSet[a]);
b_Key_P_Press_Flag = FALSE;  
}

/*****************************************************************************
*
*   Имя функции : actionKey_M_Press 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void actionKey_M_Press(void)
{
  a--;
  Shift(8, CharSet[a]);
b_Key_M_Press_Flag = FALSE;
}

/*****************************************************************************
*
*   Имя функции : actionKey_P_Long_Press 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void actionKey_P_Long_Press(void)
{
  a++;
  a++;
  Shift(8, CharSet[a]);
  b_Key_P_Long_Press_Flag = FALSE;
}

/*****************************************************************************
*
*   Имя функции : actionKey_M_Long_Press 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void actionKey_M_Long_Press(void)
{
  a--;
  a--;
  Shift(8, CharSet[a]);
  b_Key_M_Long_Press_Flag = FALSE;
}

/*****************************************************************************
*
*   Имя функции : delay_ms 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void delay_ms(uint16_t ms)
{
        TIM4_Cmd(DISABLE);       // stop
        TIM4_TimeBaseInit(TIM4_PRESCALER_128, TIM4_PERIOD);
        TIM4_ClearFlag(TIM4_FLAG_UPDATE);
        TIM4_ITConfig(TIM4_IT_UPDATE, ENABLE);

        count = ms;

        TIM4_Cmd(ENABLE);       // let's go

    while(count);
}

/*****************************************************************************
*
*   Имя функции : SystemInit 
*
*   Возвращаемые значения : Нет.
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
int SystemInit(void)
{
    
    GPIO_DeInit(LED_PORT);
    GPIO_Init(LED_PORT, LED, GPIO_MODE_OUT_PP_LOW_FAST);
    


    // ---------- CLK CONFIG -----------------------
    CLK_DeInit();

    CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
    CLK_SYSCLKConfig(CLK_PRESCALER_HSIDIV1); // set 16 MHz for CPU

    // uncomment if use HSE on Quartz
    //status = CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSE, DISABLE, CLK_CURRENTCLOCKSTATE_DISABLE);

    // ---------- TIM4 CONFIG -----------------------
    TIM4_Conf();
    GPIO_Conf();
    SPI_Conf();
    enableInterrupts();
    
    
    Shift(0x0F, 0x00);//– Тест индикатора выключен
    Shift(0x0C, 0x01);//– Выйти из сна
    Shift(0x0B, 0x07);//– Кол-во задействованных символов — 8 символов
    Shift(0x09, 0x00);//– Дешифраторы отключены
    Shift(0x0A, 0x0F);//– Интенсивность свечения (яркость) максимальна
    
    //очистить дисплей
    for(uint8_t i = 1; i < 9; i++)
    {
      Shift(i, 0);
    }
    
    
        
   
    FLASH_Unlock(FLASH_MEMTYPE_DATA);
    data = 5;
    a = FLASH_ReadByte(0x4000);
    
    
    
    return 0;
}

/*****************************************************************************
*
*   Имя функции : demo 
*
*   Возвращаемые значения : Нет.
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void demo()
{
  
}

/*****************************************************************************
*
*   Имя функции : main 
*
*   Возвращаемые значения : 
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void main(void)
{

	SystemInit();
        
        OneWire_Select(0);
        Ds18B20_Mode(THERM_MODE_12BIT);
        DS18B20_StartConvTemp();
        
        OneWire_Select(1);
        Ds18B20_Mode(THERM_MODE_12BIT);
        DS18B20_StartConvTemp();
        
        //delay_ms(750);

        demo();
                
       
	while (1){
          
          
          if(b_Key_Scan_Flag == TRUE)actionKeyScan();
          
          if(b_1S_Flag == TRUE)actionTimer_1S();
          
          if(b_Key_M_Press_Flag == TRUE)actionKey_M_Press();
          if(b_Key_P_Press_Flag == TRUE)actionKey_P_Press();
          //if(b_Key_M_Long_Press_Flag == TRUE)actionKey_M_Long_Press();
          //if(b_Key_P_Long_Press_Flag == TRUE)actionKey_P_Long_Press();

        
        
        };
        
        
}

/*****************************************************************************
*
*   Имя функции : Shift 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void Shift(uint8_t addr, uint8_t data)
{
  CS_L;
  //
  SPI->DR = addr;
  while ((SPI->SR & SPI_SR_TXE) == 0)
  {
    /* Wait while the byte is transmitted */
  }
  ///
  SPI->DR = data;
  while ((SPI->SR & SPI_SR_TXE) == 0)
  {
    /* Wait while the byte is transmitted */
  }
  //
  
  for(char i = 0; i < 20; i++){nop();}
  ///
  CS_H;
}

/*****************************************************************************
*
*   Имя функции : actionTimer_1S 
*
*   Возвращаемые значения : 
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void actionTimer_1S(void)
{

  int temp[2];
  uint8_t d[3];
       
        OneWire_Select(0);
        DS18B20_GetTemp();
        DS18B20_StartConvTemp();
        temp[ucActiveSensor] = DS18B20_ConvTempToInt10();
        
        OneWire_Select(1);
        DS18B20_GetTemp();
        DS18B20_StartConvTemp();
        temp[ucActiveSensor] = DS18B20_ConvTempToInt10();
                
        OneWire_Select(0);
        
        if(temp[ucActiveSensor] < 0)
        {
          u8LedBuffer[7] = CharSet[0x10]; // знак минус
          temp[ucActiveSensor] = -temp[ucActiveSensor];
        }
        else u8LedBuffer[7] = 0;
        d[2] = temp[ucActiveSensor] / 100;
        d[1] = (temp[ucActiveSensor] - d[2] * 100) / 10;
        d[0] = temp[ucActiveSensor] - d[2] * 100 - d[1] * 10;
        
        u8LedBuffer[6] = CharSet[d[2]]; 
        u8LedBuffer[5] = CharSet[d[1]] | 0x80; 
        u8LedBuffer[4] = CharSet[d[0]]; 
        
        OneWire_Select(1);
        
        if(temp[ucActiveSensor] < 0)
        {
          u8LedBuffer[3] = CharSet[0x10]; // знак минус
          temp[ucActiveSensor] = -temp[ucActiveSensor];
        }
        else u8LedBuffer[3] = 0;
        d[2] = temp[ucActiveSensor] / 100;
        d[1] = (temp[ucActiveSensor] - d[2] * 100) / 10;
        d[0] = temp[ucActiveSensor] - d[2] * 100 - d[1] * 10;
        
        u8LedBuffer[2] = CharSet[d[2]]; 
        u8LedBuffer[1] = CharSet[d[1]] | 0x80; 
        u8LedBuffer[0] = CharSet[d[0]]; 
        
        u8LedBuffer[7] = CharSet[a];
        
        for(uint8_t i = 0; i < 8; i++)
        {
          Shift(i+1, u8LedBuffer[i]);
        }
      
        b_1S_Flag = FALSE;

}

/*****************************************************************************
*
*   Имя функции : TIM4_Conf 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void TIM4_Conf()
{
        TIM4_Cmd(DISABLE);       // stop
        TIM4_TimeBaseInit(TIM4_PRESCALER_128, TIM4_PERIOD);
        TIM4_ClearFlag(TIM4_FLAG_UPDATE);
        TIM4_ITConfig(TIM4_IT_UPDATE, ENABLE);
        TIM4_Cmd(ENABLE);       // let's go
}
/*****************************************************************************
*
*   Имя функции : GPIO_Conf 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void GPIO_Conf()
{
  GPIO_Init(KEY_M_PORT, KEY_M_PIN,GPIO_MODE_IN_PU_NO_IT); //KEY MINUS
  GPIO_Init(KEY_P_PORT, KEY_P_PIN,GPIO_MODE_IN_PU_NO_IT); //KEY PLUS
  

  
  /* Set MSD ChipSelect pin in Output push-pull high level */
  GPIO_Init(CS_PORT, CS_PIN, GPIO_MODE_OUT_PP_HIGH_SLOW);
  GPIO_WriteHigh(CS_PORT, CS_PIN);//CS
  
  
}

/*****************************************************************************
*
*   Имя функции : SPI_Conf 
*
*   Возвращаемые значения : Нет.
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
void SPI_Conf()
{
    /* Enable SPI clock */
  CLK_PeripheralClockConfig(CLK_PERIPHERAL_SPI, ENABLE);

  /* Set the MOSI and SCK at high level */
  //GPIO_ExternalPullUpConfig(GPIOC, (GPIO_Pin_TypeDef)(GPIO_PIN_6 |GPIO_PIN_5), ENABLE);

  /* SD_SPI Configuration */
  SPI_Init( SPI_FIRSTBIT_MSB, SPI_BAUDRATEPRESCALER_16, SPI_MODE_MASTER,
           SPI_CLOCKPOLARITY_LOW, SPI_CLOCKPHASE_1EDGE, SPI_DATADIRECTION_1LINE_TX,
           SPI_NSS_SOFT, 0x07);


  /* SD_SPI enable */
  SPI_Cmd( ENABLE);


}


/*****************************************************************************
*
*   Имя функции : assert_failed 
*
*   Возвращаемые значения : Нет
*
*   Параметры : Нет.               
*
*   Задача :  
*            
*            
*****************************************************************************/
#ifdef USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */

